#tag Class
Protected Class LDS_SystemFormatting
	#tag Method, Flags = &h21
		Private Sub Constructor()
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function DecimalPoint() As string
		  evaluateSystemSettings()
		  return mDecimalPoint
		End Function
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Shared Sub evaluateSystemSettings()
		  if(configured) then return
		  var str as string
		  var num as double = 1000.1
		  str = format(num,"#,###.#")
		  
		  mDecimalPoint = str.middle(5,1)
		  mThousandsGroup=str.Middle(1,1)
		  
		  system.DebugLog("Got '"+str+"' => DP"+mDecimalPoint+" TH"+mThousandsGroup)
		  
		  // now kDigits and kDigitsAndKeys
		  mkDigits = "0123456789"
		  // digits Plus . and -
		  mkDigitsPlus = "0123456789-"+mDecimalPoint
		  // this is Backspace, Tab, Left, Right, Up, Down, Delete
		  mkDigitsAndKeys = "0123456789-"+mDecimalPoint+chr(8)+chr(9)+chr(28)+chr(29)+chr(30)+chr(31)+chr(127)
		  
		  
		  Configured = true
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function kDigits() As string
		  evaluateSystemSettings()
		  return mKDigits
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function kDigitsAndKeys() As string
		  evaluateSystemSettings()
		  return mKDigitsAndKeys
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function kDigitsPlus() As string
		  evaluateSystemSettings()
		  return mKDigitsPlus
		End Function
	#tag EndMethod

	#tag Method, Flags = &h0
		Shared Function ThousandsGroup() As string
		  return mThousandsGroup
		End Function
	#tag EndMethod


	#tag Property, Flags = &h21
		Private Shared Configured As boolean = false
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Shared mDecimalPoint As string = "-"
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Shared mKDigits As string
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Shared mKDigitsAndKeys As string
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Shared mKDigitsPlus As string
	#tag EndProperty

	#tag Property, Flags = &h21
		Private Shared mThousandsGroup As string = "-"
	#tag EndProperty


	#tag ViewBehavior
		#tag ViewProperty
			Name="Name"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Index"
			Visible=true
			Group="ID"
			InitialValue="-2147483648"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Super"
			Visible=true
			Group="ID"
			InitialValue=""
			Type="String"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Left"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
		#tag ViewProperty
			Name="Top"
			Visible=true
			Group="Position"
			InitialValue="0"
			Type="Integer"
			EditorType=""
		#tag EndViewProperty
	#tag EndViewBehavior
End Class
#tag EndClass
